|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
java.lang.Objectorg.opencms.loader.CmsImageScaler
public class CmsImageScaler
Creates scaled images, acting as it's own parameter container.
| Field Summary | |
|---|---|
static String |
COLOR_TRANSPARENT
The name of the transparent color (for the backgound image). |
static String |
FILTER_GRAYSCALE
The name of the grayscale image filter. |
static String |
FILTER_SHADOW
The name of the shadow image filter. |
static List |
FILTERS
The supported image filter names. |
protected static Log |
LOG
The log object for this class. |
static String |
PARAM_SCALE
The (optional) parameter used for sending the scale information of an image in the http request. |
static int |
SCALE_DEFAULT_MAX_BLUR_SIZE
The default maximum image size (width * height) to apply image blurring when downscaling (setting this to high may case "out of memory" errors). |
static int |
SCALE_DEFAULT_MAX_SIZE
The default maximum image size (width or height) to allow when updowscaling an image using request parameters. |
static String |
SCALE_PARAM_COLOR
The scaler parameter to indicate the requested image background color (if required). |
static String |
SCALE_PARAM_FILTER
The scaler parameter to indicate the requested image filter. |
static String |
SCALE_PARAM_HEIGHT
The scaler parameter to indicate the requested image height. |
static String |
SCALE_PARAM_POS
The scaler parameter to indicate the requested image position (if required). |
static String |
SCALE_PARAM_QUALITY
The scaler parameter to indicate to requested image save quality in percent (if applicable, for example used with JPEG images). |
static String |
SCALE_PARAM_RENDERMODE
The scaler parameter to indicate to requested settings. |
static String |
SCALE_PARAM_TYPE
The scaler parameter to indicate the requested scale type. |
static String |
SCALE_PARAM_WIDTH
The scaler parameter to indicate the requested image width. |
| Constructor Summary | |
|---|---|
CmsImageScaler()
Creates a new, empty image scaler object. |
|
CmsImageScaler(byte[] content,
String rootPath)
Creates a new image scaler for the given image contained in the byte array. |
|
CmsImageScaler(CmsImageScaler original,
CmsImageScaler scaler)
Creates a new image scaler that is a recale from the original size to the given scaler. |
|
CmsImageScaler(CmsObject cms,
CmsResource res)
Creates a new image scaler by reading the property
from the given resource. |
|
CmsImageScaler(HttpServletRequest request,
int maxScaleSize,
int maxBlurSize)
Creates a new image scaler based on the given http request. |
|
CmsImageScaler(String parameters)
Creates a new image scaler based on the given parameter String. |
|
| Method Summary | |
|---|---|
void |
addFilter(String filter)
Adds a filter name to the list of filters that should be applied to the image. |
Object |
clone()
|
Color |
getColor()
Returns the color. |
String |
getColorString()
Returns the color as a String. |
List |
getFilters()
Returns the list of image filter names (Strings) to be applied to the image. |
String |
getFiltersString()
Returns the list of image filter names (Strings) to be applied to the image as a String. |
int |
getHeight()
Returns the height. |
String |
getImageType(String filename)
Returns the image type from the given file name based on the file suffix (extension) and the available image writers. |
int |
getPosition()
Returns the position. |
int |
getQuality()
Returns the image saving quality in percent (0 - 100). |
int |
getRenderMode()
Returns the image rendering mode constant. |
int |
getType()
Returns the type. |
int |
getWidth()
Returns the width. |
int |
hashCode()
|
boolean |
isValid()
Returns true if all required parameters are available. |
byte[] |
scaleImage(CmsFile file)
Returns a scaled version of the given image file according this image scalers parameters. |
void |
setColor(Color color)
Sets the color. |
void |
setColor(String value)
Sets the color as a String. |
void |
setFilters(String value)
Sets the list of filters as a String. |
void |
setHeight(int height)
Sets the height. |
void |
setPosition(int position)
Sets the scale position. |
void |
setQuality(int quality)
Sets the image saving quality in percent. |
void |
setRenderMode(int renderMode)
Sets the image rendering mode constant. |
void |
setType(int type)
Sets the scale type. |
void |
setWidth(int width)
Sets the width. |
String |
toRequestParam()
Creates a request parameter configured with the values from this image scaler, also appends a '?' char as a prefix so that this may be direclty appended to an image URL. |
String |
toString()
|
| Methods inherited from class java.lang.Object |
|---|
equals, finalize, getClass, notify, notifyAll, wait, wait, wait |
| Field Detail |
|---|
public static final String COLOR_TRANSPARENT
public static final String FILTER_GRAYSCALE
public static final String FILTER_SHADOW
public static final List FILTERS
public static final String PARAM_SCALE
public static final int SCALE_DEFAULT_MAX_BLUR_SIZE
public static final int SCALE_DEFAULT_MAX_SIZE
public static final String SCALE_PARAM_COLOR
public static final String SCALE_PARAM_FILTER
public static final String SCALE_PARAM_HEIGHT
public static final String SCALE_PARAM_POS
public static final String SCALE_PARAM_QUALITY
public static final String SCALE_PARAM_RENDERMODE
RenderingHints settings.
public static final String SCALE_PARAM_TYPE
public static final String SCALE_PARAM_WIDTH
protected static final Log LOG
| Constructor Detail |
|---|
public CmsImageScaler()
public CmsImageScaler(byte[] content,
String rootPath)
Please note:The image itself is not stored in the scaler, only the width and
height dimensions of the image. To actually scale an image, you need to use
. This constructor is commonly used only
to extract the image dimensions, for example when creating a String value for
the scaleImage(CmsFile) property.CmsPropertyDefinition.PROPERTY_IMAGE_SIZE
In case the byte array can not be decoded to an image, or in case of other errors,
will return isValid()false.
content - the image to calculate the dimensions forrootPath - the root path of the resource (for error logging)
public CmsImageScaler(CmsImageScaler original,
CmsImageScaler scaler)
original - the scaler that holds the original image dimensionsscaler - the image scaler to be used for rescaling this image scaler
public CmsImageScaler(CmsObject cms,
CmsResource res)
CmsPropertyDefinition.PROPERTY_IMAGE_SIZE
from the given resource.
In case of any errors reading or parsing the property,
will return isValid()false.
cms - the OpenCms user context to use when reading the propertyres - the resource to read the property from
public CmsImageScaler(HttpServletRequest request,
int maxScaleSize,
int maxBlurSize)
request - the http request to read the parameters frommaxScaleSize - the maximum scale size (width or height) for the imagemaxBlurSize - the maximum size of the image (width * height) to apply blur (may cause "out of memory" for large images)public CmsImageScaler(String parameters)
parameters - the scale parameters to use| Method Detail |
|---|
public void addFilter(String filter)
filter - the filter name to addpublic Object clone()
clone in class ObjectObject.clone()public Color getColor()
public String getColorString()
public List getFilters()
public String getFiltersString()
public int getHeight()
public String getImageType(String filename)
For example, for the file name "opencms.gif" the type is GIF, for "opencms.jpg" is is "JPEG" etc.
In case the input filename has no suffix, or there is no known image writer for the format defined
by the suffix, null is returned.
Any non-null result can be used if an image type input value is required.
filename - the file name to get the type for
public int getPosition()
public int getQuality()
This is used oly if applicable, for example when saving JPEG images.
public int getRenderMode()
Possible values are:
Simapi.RENDER_QUALITY (default)Simapi.RENDER_SPEEDSimapi.RENDER_MEDIUMSimapi.RENDER_QUALITY mode.
public int getType()
Possible values are:
public int getWidth()
public int hashCode()
hashCode in class ObjectObject.hashCode()public boolean isValid()
true if all required parameters are available.Required parameters are "h" (height), and "w" (width).
true if all required parameters are availablepublic byte[] scaleImage(CmsFile file)
file - the image file to scale
public void setColor(Color color)
color - the color to setpublic void setColor(String value)
value - the color to setpublic void setFilters(String value)
value - the list of filters to setpublic void setHeight(int height)
height - the height to setpublic void setPosition(int position)
position - the position to setpublic void setQuality(int quality)
quality - the image saving quality (in percent) to setpublic void setRenderMode(int renderMode)
renderMode - the image rendering mode to setfor a list of allowed values for the rendering modepublic void setType(int type)
type - the scale type to setfor a detailed description of the possible values for the typepublic void setWidth(int width)
width - the width to setpublic String toRequestParam()
'?' char as a prefix so that this may be direclty appended to an image URL.This can be appended to an image request in order to apply image scaling parameters.
public String toString()
toString in class ObjectObject.toString()
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||